/********************/
/*    bsound.cpp    */
/********************/
#include "stdafx.h"
#include "mmsystem.h"
#include "bsound.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4244)

/////////////////////////////////////////////////////////////////////////////
// CBasicSound

IMPLEMENT_SERIAL(CBasicSound, CObject, 0 /* Schema number */ )

CBasicSound::CBasicSound()
{
    m_pSoundImage = NULL;
}

CBasicSound::~CBasicSound()
{
    if (m_pSoundImage) GlobalFree(m_pSoundImage);
}


/////////////////////////////////////////////////////////////////////////////
// CBasicSound serialization

void CBasicSound::Serialize(CArchive& ar)
{
    ASSERT(0); // Not supported.          // BUGFIX
}

/////////////////////////////////////////////////////////////////////////////
// CBasicSound commands

BOOL CBasicSound::Load(CFile* fp)
{
    // Load the whole file into memory.
    // Free any existing memory.
    if (m_pSoundImage) GlobalFree(m_pSoundImage);
    // Allocate a new block big enough for the entire file.
    int iLength = fp->GetLength();
    m_pSoundImage = (char*) ::GlobalAlloc(GPTR, iLength);
    ASSERT(m_pSoundImage);
    // Read the entire file into memory.
    int iBytes = fp->Read(m_pSoundImage, iLength);
    ASSERT(iBytes == iLength);        
    return TRUE;
}

BOOL CBasicSound::Play()
{
    if (!m_pSoundImage) return FALSE; // Nothing to play.
    return ::sndPlaySound(m_pSoundImage,
                          SND_MEMORY | SND_ASYNC | SND_NODEFAULT);
}
