/*************************/
/*    DlgCreateDB.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgCreateDB.h"
#include <direct.h>
#include "statusbox.h"
#include "osversion.h"
#include "dlgdir.h"
#include "dlgselectdir.h"
extern "C" {
#include <rdb.h>
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCreateDB _CAO


CDlgCreateDB::CDlgCreateDB(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCreateDB::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCreateDB)
	m_strShgdb = _T("");
	//}}AFX_DATA_INIT
}


void CDlgCreateDB::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCreateDB)
	DDX_Text(pDX, IDC_EDIT_SHGDB, m_strShgdb);
	DDV_MaxChars(pDX, m_strShgdb, 128);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCreateDB, CDialog)
	//{{AFX_MSG_MAP(CDlgCreateDB)
	ON_BN_CLICKED(IDOK, OnCreateDB)
	ON_BN_CLICKED(IDC_SELDIR, OnSelDir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCreateDB bZ[W nh

////////
/// f[^x[X쐬Xbh
static void PrintMessage(CStatusBox *pBox,char *message)
{
	if (pBox)
		pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)message);
	else
		TRACE("%s\n",message);
}
static UINT CreateDBWorkerThread(CStatusBox *pBox,CEvent *pEvent,LPARAM lParam)
{
	CDlgCreateDB *pDlg=(CDlgCreateDB *)lParam;

	/////////////////////////////////
	//  f[^x[X̍쐬
	/////////////////////////////////
	int rc;

	// Ֆʕ\(SHGDB_A)̍쐬
	char *sqltext = "create table SHGDB_A ( \
		A_HASH		char (6),	\
		A_SYNONYM	char (2),	\
		A_BFORM		bin	 (44),	\
		A_REFCOUNT  bin  (4)	\
	   )";
	if ((rc=SqlCreateTable(sqltext))!=E$OK) {
		PrintMessage(pBox,"Ֆʕ\(SHGDB_A)̍쐬Ɏs܂B");
		goto exit;
	}
	// SHGDB_A̍
	sqltext = "create unique index 0 on SHGDB_A (A_HASH,A_SYNONYM)";
	if ((rc=SqlCreateIndex(sqltext))!=E$OK) {
		PrintMessage(pBox," SHGDB_A ̍쐬Ɏs܂B");
		goto exit;
	}
	PrintMessage(pBox,"Ֆʕ\(SHGDB_A)쐬܂B");

	// ΋Ǖ\(SHGDB_B)̍쐬
	sqltext = "create table SHGDB_B ( \
		΋ǎ		char (29),	\
		΋Ǔ		char (8),	\
		i	char (10),	\
		i	char (10),	\
		荇		char (6),	\
				char (6),	\
		b		char (2),	\
			char (6),	\
		萔		char (4),	\
		c	char (6),	\
		c	char (6),	\
		^		char (40),	\
		햼		char (40),	\
		΋Ǐꏊ	char (40),	\
		o^	char (14),	\
		Ֆ	char (8),	\
				char (1),	\
		΋ǔԍ	char (6),	\
		\		char (8)	\
	)";
	if ((rc=SqlCreateTable(sqltext))!=E$OK) {
		PrintMessage(pBox,"΋Ǖ\(SHGDB_B)̍쐬Ɏs܂B");
		goto exit;
	}
	// SHGDB_B̍
	sqltext = "create index 0 on SHGDB_B (΋ǎ)";
	if ((rc=SqlCreateIndex(sqltext))!=E$OK) {
		PrintMessage(pBox," SHGDB_B ̍쐬Ɏs܂B");
		goto exit;
	}
	PrintMessage(pBox,"΋Ǖ\(SHGDB_B)쐬܂B");

	// l\(SHGDB_C)̍쐬
	sqltext = "create table SHGDB_C ( \
				char (18),	\
		l萔		char (4),	\
		qg		char (40),	\
		Փx		char (14),	\
		\		char (50),	\
		o^	char (14),	\
		o}		char (8),	\
		lԍ	char (6),	\
		\		char (6)	\
	)";
	if ((rc=SqlCreateTable(sqltext))!=E$OK) {
		PrintMessage(pBox,"l\(SHGDB_C)̍쐬Ɏs܂B");
		goto exit;
	}
	// SHGDB_C̍
	sqltext = "create unique index 0 on SHGDB_C (o})";
	if ((rc=SqlCreateIndex(sqltext))!=E$OK) {
		PrintMessage(pBox," SHGDB_C ̍쐬Ɏs܂B");
		goto exit;
	}
	PrintMessage(pBox,"l\(SHGDB_C)쐬܂B");

	// \(SHGDB_D)̍쐬
	sqltext = "create table SHGDB_D ( \
		D_RECID		char (1),	\
		D_RECNO		char (6),	\
		D_SNO		char (2),	\
		D_BPLAY		bin	 (40),	\
		D_DUMMY		char (11)	\
	)";
	if ((rc=SqlCreateTable(sqltext))!=E$OK) {
		PrintMessage(pBox,"\(SHGDB_D)̍쐬Ɏs܂B");
		goto exit;
	}
	// SHGDB_D̍
	sqltext = "create unique index 0 on SHGDB_D (D_RECID,D_RECNO,D_SNO)";
	if ((rc=SqlCreateIndex(sqltext))!=E$OK) {
		PrintMessage(pBox," SHGDB_D ̍쐬Ɏs܂B");
		goto exit;
	}
	PrintMessage(pBox,"\(SHGDB_D)쐬܂B");

	// Օ\(SHGDB_E)̍쐬
	sqltext = "create table SHGDB_E ( \
		E_HASH_S	char (8),	\
		E_SIDE		char (1),	\
		E_EVAL		bin	 (2),	\
		E_MOVE		bin	 (40),	\
		E_DUMMY		char (1)	\
	)";
	if ((rc=SqlCreateTable(sqltext))!=E$OK) {
		PrintMessage(pBox,"Օ\(SHGDB_E)̍쐬Ɏs܂B");
		goto exit;
	}
	// SHGDB_E̍
	sqltext = "create index 0 on SHGDB_E (E_HASH_S,E_SIDE)";
	if ((rc=SqlCreateIndex(sqltext))!=E$OK) {
		PrintMessage(pBox," SHGDB_E ̍쐬Ɏs܂B");
		goto exit;
	}
	PrintMessage(pBox,"Օ\(SHGDB_E)쐬܂B");

	// ߕ\(SHGDB_F)̍쐬
	sqltext = "create table SHGDB_F ( \
		F_COMMENTID		char (1),	\
		F_COMMENTKEY	char (12),	\
		F_SNO			char (2),	\
		F_SENTENCE		char (45)	\
	)";
	if ((rc=SqlCreateTable(sqltext))!=E$OK) {
		PrintMessage(pBox,"ߕ\(SHGDB_F)̍쐬Ɏs܂B");
		goto exit;
	}
	// SHGDB_F̍
	sqltext = "create unique index 0 on SHGDB_F (F_COMMENTKEY,F_COMMENTID,F_SNO)";
	if ((rc=SqlCreateIndex(sqltext))!=E$OK) {
		PrintMessage(pBox," SHGDB_F ̍쐬Ɏs܂B");
		goto exit;
	}
	PrintMessage(pBox,"ߕ\(SHGDB_F)쐬܂B");

	PrintMessage(pBox,"f[^x[X͐ɍ쐬܂B");

exit:
	return 0;
}

///////
// VKf[^x[X̍쐬
void CDlgCreateDB::OnCreateDB() 
{
	UpdateData(TRUE);

	if (m_strShgdb.IsEmpty()) // f[^ȂB
		return;
	
	int rc=_mkdir(m_strShgdb);
	if (rc!=0) {
		CString mes = "VKfBNg̍쐬Ɏs܂B\n";
		mes += "(tH_ɂ͍쐬ł܂)";
		AfxMessageBox(mes);
		return;
	}

	// JgfBNg̎擾
	char CurrDir[256];
	if (GetCurrentDirectory(sizeof CurrDir,CurrDir)==0)
		return; // JgfBNg̎擾Ɏs
	if (!SetCurrentDirectory(m_strShgdb))
		return;

	// j^{bNX & ƊJn
	CStatusBox StatusBox(&CreateDBWorkerThread,(LPARAM)this);
	StatusBox.DoModal();

	SetCurrentDirectory(CurrDir); // ɖ߂B

	CDialog::OnOK(); // OKI
}

/////
// fBNg̑I
void CDlgCreateDB::OnSelDir() 
{
	COsVersion OsVersion; // OS Version 

	if (OsVersion.m_OsVersionType >=2 ) { // Win95,NT4.0 ȏ
		CDlgSelectDir DlgSelectDir; // fBNgI_CAO
		
		if (DlgSelectDir.DoModal()==IDOK) {
			m_strShgdb=DlgSelectDir.m_strSelectDir;
			UpdateData(FALSE);
		}
	} 
	else { // NT3.51
		CDlgDir DlgDir;

		if (DlgDir.DoModal()==IDOK) {
			m_strShgdb=DlgDir.strSelPathName;
			UpdateData(FALSE);
		}
	}
}
