/**********************/
/*    DlgOutJS.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgOutJS.h"
#include "StatusBox.h"
#include <dbe.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgOutJS _CAO

CDlgOutJS::CDlgOutJS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOutJS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgOutJS)
	m_strFileName = _T("");
	m_Depth = 1;
	m_bComment = FALSE;
	//}}AFX_DATA_INIT
}

void CDlgOutJS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOutJS)
	DDX_Text(pDX, IDC_CSA_FILENAME, m_strFileName);
	DDV_MaxChars(pDX, m_strFileName, 256);
	DDX_Text(pDX, IDC_EDIT_NUM, m_Depth);
	DDV_MinMaxInt(pDX, m_Depth, 1, 300);
	DDX_Check(pDX, IDC_COMMENT, m_bComment);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgOutJS, CDialog)
	//{{AFX_MSG_MAP(CDlgOutJS)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	ON_BN_CLICKED(IDC_DISPLAY, OnDisplay)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOutJS bZ[W nh

///////
// t@C̑I
void CDlgOutJS::OnFileSelect() 
{
	if (!UpdateData(TRUE))
		return;

	CString strFile=m_strFileName;
	if (strFile.IsEmpty())
		// CSAt@C(fBNĝ)
		strFile.Format("%s*.pcl",GetShgdbName()); 

	CFileDialog dlgJS(TRUE,	// Ǎ݃_CAO
			"pcl",				// ftHggq
			strFile,	    // ftHgPCLt@C
			(DWORD)(OFN_HIDEREADONLY), // t@C̑
			"CSAt@C (*.pcl)|*.pcl| CSAt@C (*.csa)|*.csa||");
	BOOL bResult = dlgJS.DoModal();

	if (bResult == IDOK) { // I
		m_strFileName = dlgJS.GetPathName();
		UpdateData(FALSE);
	}
}

////////////////////////
// Ճt@Co [J[Xbh
//   t@CI[vāAՂt@Cɏo͂B
static UINT OutputThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgOutJS *pDlgOutJS=(CDlgOutJS *)lParam;
	CString *pstrFile	=&pDlgOutJS->m_strFileName;
	CString strFile	=*pstrFile;
	CBform Bform(&pDlgOutJS->m_Bform);
	int side		=pDlgOutJS->m_side;
	int Depth		=pDlgOutJS->m_Depth;
	BOOL bComment	=pDlgOutJS->m_bComment;
	long total;
	char StringBuffer[256];

	BOOL bQuit=FALSE;

	CDBE Dbe;
	if (!Dbe.Open()) { // DB I[vs
		return 1;
	}
	
	Dbe.SetQuitObject((HANDLE)(*pStopEvent)); // fCxg̐ݒ
	Dbe.CommentWriteEnable(bComment);		  // ߏo̗͂L

	if (strFile.IsEmpty()) {
		// CSAt@Ci[t@CI[vG[
		CString str;
		str.Format("t@C͂ĂB");
		AfxMessageBox(str);
		bQuit=TRUE;
	}

	if (!bQuit) {
		CFile f;
		// t@C̃I[v
		if (f.Open(strFile,
			CFile::modeReadWrite | CFile::modeCreate | CFile::shareDenyWrite
			)) { 
			CSDJArchive ar(&f,CArchive::store);
			Dbe.SetMessageWindow(pBox);
			// CSAt@C̓e΋ǂca֓o^B
			total=Dbe.OutDBE2Csa(ar,&Bform,side,Depth);
			ar.Close();
			f.Close();
			if (total > 0L) {
				sprintf(StringBuffer,"%ld  o͂܂B",total);
			} else {
				sprintf(StringBuffer,"w̏o͂͂܂B");
			}
			pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);
		}
		else { // CSAt@CI[vG[
			CString str;
			str.Format("t@C(%s)I[vł܂B",strFile);
			AfxMessageBox(str);
			bQuit=TRUE;
		}
	}

	Dbe.Close();
	return (UINT)(!bQuit);
}

//////
// t@Co
void CDlgOutJS::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	// CSA t@C̃I[v`FbN
	CFile fcsa;
	int MBret=IDYES;
	if (fcsa.Open(m_strFileName,CFile::modeReadWrite | CFile::shareDenyWrite)) {
		CString strbuf;
		strbuf.Format("t@C(%s)ɏ㏑Ă낵łH",m_strFileName);
		MBret=AfxMessageBox(strbuf,MB_YESNO);
		fcsa.Close();
	}
	if (MBret!=IDYES)
		return;

	// t@C̋L
	theApp.WriteProfileString(JS_SECTION,JS_OUTFILENAME,m_strFileName);

	// Տo͏
	CStatusBox StatusBox(&OutputThread,(LPARAM)this); // t@C̏o
	StatusBox.DoModal();
	
	CDialog::OnOK();
}

BOOL CDlgOutJS::OnInitDialog() 
{
	// ftHg̃t@C
	CString defFileName;
	defFileName.Format("%sJsout.pcl",GetShgdbName());
	m_strFileName=theApp.GetProfileString(JS_SECTION,JS_OUTFILENAME,defFileName);

	CDialog::OnInitDialog();
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////////////////////////
// Ճj^o [J[Xbh
//   PCLt@Cej^֏o͂B
static UINT DispThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgOutJS *pDlgOutJS=(CDlgOutJS *)lParam;
	CBform Bform(&pDlgOutJS->m_Bform);
	int side		=pDlgOutJS->m_side;
	int Depth		=pDlgOutJS->m_Depth;
	BOOL bComment	=pDlgOutJS->m_bComment;
	long total;
	char StringBuffer[256];

	CDBE Dbe;
	if (!Dbe.Open()) { // DB I[vs
		return 1;
	}
	
	Dbe.SetQuitObject((HANDLE)(*pStopEvent)); // fCxg̐ݒ
	Dbe.CommentWriteEnable(bComment);		  // ߏo̗͂L
	Dbe.SetMessageWindow(pBox);

	// ՂCSA`Ńj^o͂B
	total=Dbe.DispDBE2Csa(&Bform,side,Depth);
	if (total > 0L) {
		sprintf(StringBuffer,"%ld  o͂܂B",total);
	} else {
		sprintf(StringBuffer,"w̏o͂͂܂B");
	}
	pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);

	Dbe.Close();
	return 0;
}

///////////
// \mF
void CDlgOutJS::OnDisplay() 
{
	if (!UpdateData(TRUE))
		return;

	// Տo͏
	CStatusBox StatusBox(&DispThread,(LPARAM)this); // t@C̏o
	StatusBox.DoModal();
}
