/***********************/
/*    kmlistbox.cpp    */
/***********************/
#include "stdafx.h"
#include "kmlistbox.h"
#include "kmsprite.h"
#include "winsdj.h"
#include "kif.h"
#include "sdjview.h"
#include <sbase.h>
#include "kbase.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// Ckmlistbox
CKmListBox::CKmListBox()
{
	m_Spoint.x=m_Spoint.y=0;  // _
	m_pKBase=NULL;  // KBase;

	Reset();
}

CKmListBox::CKmListBox(int x, int y,int side)
{
	m_Spoint.x	=x;
	m_Spoint.y	=y;
	m_iKmNum=0;            // 

	Reset();
}

void CKmListBox::Reset()
{
	m_iKmNum=0;            // 
	for (int i=0;i<40;i++)
		m_pKmList[i]=NULL; // NULLNA
}

CKmListBox::~CKmListBox()
{
}

// ̒ǉ
BOOL CKmListBox::Insert(CKmSprite *pKmSprite,BOOL bSort,BOOL bChange)
{
	int sg,km,nr;

	pKmSprite->GetKmStatus(&sg,&km,&nr);
	if (sg!=GetSide() || nr!=0 ) {  // ̕\()pɏC
		sg=GetSide();
		nr=0;
		pKmSprite->SetKmStatus(sg,km,nr);
	}

	ASSERT(!(m_iKmNum==40));
	m_pKmList[m_iKmNum]=pKmSprite; // ǉ
	m_iKmNum++;
	
	if (bSort)
		SortAndUpdateDirtyRegion(bChange); // \[g\(AddDirtyRegion)

	return TRUE;
}

// ̍폜
BOOL CKmListBox::Remove(CKmSprite *pKmSprite,BOOL bSort,BOOL bDisp)
{
	int i,j;

	for (i=0;i<m_iKmNum;i++) {
		if (m_pKmList[i]==pKmSprite) {
			for (j=i+1;j<m_iKmNum;j++) {
				m_pKmList[j-1]=m_pKmList[j];
			}
			m_iKmNum--;
			break;
		}
	}
	if (bSort)
		SortAndUpdateDirtyRegion(bDisp); // \[g\

	return TRUE;
}

// ̃\[g\
void CKmListBox::SortAndUpdateDirtyRegion(BOOL bChange)
{
	int sg,km,nr;
	int i,j;
	int iKind[8];					// ʋ
	CKmSprite *pKindArray[8][20];   // ʋXg
	int kn;		// \ʒuJE^(0~9 0:1i 1~2:2i,3~4:3i,5,6,7:4i)
	CPoint kp;  // knɑΉ\JnʒuW
	int dx;     // 2ڈȍ~̂炵
	int iZ;     // Z

	// XgʃXgփRs[
	for (i=0;i<8;i++) iKind[i]=0;
	for (i=0;i<m_iKmNum;i++) {
		m_pKmList[i]->GetKmStatus(&sg,&km,&nr); // ̎擾
		ASSERT(!(km < 0 || km > 7));
		ASSERT(!(iKind[km] >= 20));
		pKindArray[km][iKind[km]++]=m_pKmList[i]; // ʋXgɊi[
	}
	// ʃXgXgփRs[
	for (kn=0,m_iKmNum=0,i=7;i>=0;i--) {
		CKif Kif;
		int side=GetSide();
		Kif.calc_xsdx(m_Spoint,side,kn,iKind[i],&kp,&dx); // \ʒǔvZ
		if (kn==0 || kn==1 || kn==3 || kn==5)
			iZ=50;	// Z
		for (j=0;j<iKind[i];j++) {
			if (kn < 7) { // ̕Wʒu
				pKindArray[i][j]->SetPosition(kp.x+j*dx,kp.y,bChange); // GUIʒu
				pKindArray[i][j]->SetZ(--iZ,bChange);				   // Z 
				pKindArray[i][j]->SetBoxKx(kn); // kn ̋L
			}
			else {  // ̒
				pKindArray[i][j]->SetPosition(kp.x, kp.y+j*dx,bChange); // GUIʒu
				pKindArray[i][j]->SetZ(30,bChange);					    // Z 
				pKindArray[i][j]->SetBoxKx(kn); // kn ̋L
			}
			m_pKmList[m_iKmNum++]=pKindArray[i][j];		// Xgɒǉ
		}
		if (iKind[i]>0)	kn++;		// i̒ǉʒu+1
	}
}

// HBOXz֐
void CKmListBox::setpos(int pos)
{
	int za=m_pKBase->GetZa(); // 
	switch (pos) {
	case SIDE_A:
		if (za==0)
			SetSpoint(Sdaix1,Sdaiy1);
		else
			SetSpoint(Gdaix2,Gdaiy2);
		break;
	case SIDE_B:
		if (za==0)
 			SetSpoint(Gdaix2,Gdaiy2);
		else
			SetSpoint(Sdaix1,Sdaiy1);
		break;
	case ON_BOX:
		SetSpoint(KBoxx1,KBoxy1); break;
	default:
		ASSERT(0);
	}
	HBOX::setpos(pos);
}

// ̋side擾
// side(0=SIDE_A/ 1=SIDE_B)Ԃ
int CKmListBox::GetSide(void)
{
	int pos=getpos(); // ΍Wside
	int side=pos;

	if (pos==ON_BOX) {
		side=SIDE_A;  // ͎
	} 
	else if (m_pKBase->GetZa()) { // ]Ȃ甽]
		if (pos==SIDE_A)
			side=SIDE_B;
		if (pos==SIDE_B)
			side=SIDE_A;
	}

	return side;
}

//  ]
void CKmListBox::ZaRotation(void)
{
	if (getpos()==ON_BOX)
		return ; // Ȃ牽ȂB

	// Ȃ_ւ
	CPoint p=GetSpoint();
	if (p.x==Sdaix1)
		SetSpoint(Gdaix2,Gdaiy2);
	else
		SetSpoint(Sdaix1,Sdaiy1);
}
