/*********************/
/*    MainFrm.cpp    */
/*********************/
#include "stdafx.h"
#include "winsdj.h"
#include "mainfrm.h"
#include "ssdjdoctemplate.h"
#include "tooldlg.h"
#include "sdjview.h"
#include "sdjdoc.h"
#include <dba.h>
#include <mbstring.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TOOLBAR_SECTION		 "TOOLBAR"
#define VISIBLE_STANDBAR	 "VisibleStandardBar"
#define FLOATING_STANDBAR	 "FloartingStandardBar"
#define STANDBAR_POSX		 "StandardBarPos_x"
#define STANDBAR_POSY		 "StandardBarPos_y"
#define VISIBLE_PLAYBAR		 "VisiblePlayBar"
#define FLOATING_PLAYBAR	 "FloartingPlayBar"
#define PLAYBAR_POSX		 "PlayBarPos_x"
#define PLAYBAR_POSY		 "PlayBarPos_y"
#define VISIBLE_DATABASEBAR	 "VisibleDataBaseBar"
#define FLOATING_DATABASEBAR "FloartingDataBaseBar"
#define DATABASEBAR_POSX	 "DataBaseBarPos_x"
#define DATABASEBAR_POSY	 "DataBaseBarPos_y"

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_COMMAND(ID_TOOLS_TOOLBAR, OnToolsToolbar)
	ON_WM_PALETTECHANGED()
	//}}AFX_MSG_MAP
	// O[o wv R}h
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_WAKEUP,OnWakeUp)
	ON_COMMAND(ID_WAKEUP_OPEN,OnWakeUpOpen)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_SHGDB,OnUpdateShgdb)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	ID_INDICATOR_SHGDB,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	m_iCloseLock=0;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndStandardBar.Create(this) ||
		!m_wndStandardBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}
	if (!m_wndPlayBar.Create(this) ||
		!m_wndPlayBar.LoadToolBar(IDR_PLAYCTRL))
	{
		TRACE0("Failed to create playctrl bar\n");
		return -1;      // 쐬Ɏs
	}
	if (!m_wndDataBaseBar.Create(this) ||
		!m_wndDataBaseBar.LoadToolBar(IDR_DATABASE))
	{
		TRACE0("Failed to create playctrl bar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndStandardBar.SetBarStyle(m_wndStandardBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndPlayBar.SetBarStyle(m_wndPlayBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndDataBaseBar.SetBarStyle(m_wndDataBaseBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ6s폜
	// ȉ6sŃc[o[Ɉē\悤ɂȂB
	m_wndStandardBar.SetWindowText("W");
	m_wndStandardBar.EnableDocking(CBRS_ALIGN_ANY);

	m_wndPlayBar.SetWindowText("");
	m_wndPlayBar.EnableDocking(CBRS_ALIGN_ANY);

	m_wndDataBaseBar.SetWindowText("f[^x[X");
	m_wndDataBaseBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY); // Ct[̃hbLO

	// c[o[̏(vt@C`FbN)
	CString strSection=TOOLBAR_SECTION;

	// Wc[o[
	BOOL bVisibleStandBar  = theApp.GetProfileInt(strSection,VISIBLE_STANDBAR,1);
	BOOL bFloatingStandBar = theApp.GetProfileInt(strSection,FLOATING_STANDBAR,0);
	if (bFloatingStandBar) {
		int px = theApp.GetProfileInt(strSection,STANDBAR_POSX,500);
		int py = theApp.GetProfileInt(strSection,STANDBAR_POSY,240);
		CPoint pt(px,py);
		FloatControlBar(&m_wndStandardBar,pt); // t[eBO
	} else {
		DockControlBar(&m_wndStandardBar);		  // hbLO
	}
	if (!bVisibleStandBar) {
		ShowControlBar(&m_wndStandardBar,FALSE,FALSE);
	}

	// c[o[
	BOOL bVisiblePlayBar  = theApp.GetProfileInt(strSection,VISIBLE_PLAYBAR,1);
	BOOL bFloatingPlayBar = theApp.GetProfileInt(strSection,FLOATING_PLAYBAR,0);
	if (bFloatingPlayBar) {
		int px = theApp.GetProfileInt(strSection,PLAYBAR_POSX,500);
		int py = theApp.GetProfileInt(strSection,PLAYBAR_POSY,280);
		CPoint pt(px,py);
		FloatControlBar(&m_wndPlayBar,pt); // t[eBO
		// ŁAt[eBOԂ̋c[o[͂Qiɂ̂A
		// ̂ȂB
	} else {
		if (bVisibleStandBar && !bFloatingStandBar) {
			// ȉDOCKTOOL sample 
			// ̃c[o[W̃c[o[̉EփhbLOB
			RecalcLayout();
			CRect rect;
			m_wndStandardBar.GetWindowRect(&rect);
			rect.OffsetRect(1,0);
			DockControlBar(&m_wndPlayBar,(UINT)0,&rect);
		} else {
			DockControlBar(&m_wndPlayBar);
		}
	}
	if (!bVisiblePlayBar) {
		ShowControlBar(&m_wndPlayBar,FALSE,FALSE);
	} 

	// f[^x[Xc[o[
	BOOL bVisibleDataBaseBar  = theApp.GetProfileInt(strSection,VISIBLE_DATABASEBAR,1);
	BOOL bFloatingDataBaseBar = theApp.GetProfileInt(strSection,FLOATING_DATABASEBAR,0);
	if (bFloatingDataBaseBar) {
		int px = theApp.GetProfileInt(strSection,DATABASEBAR_POSX,500);
		int py = theApp.GetProfileInt(strSection,DATABASEBAR_POSY,320);
		CPoint pt(px,py);
		FloatControlBar(&m_wndDataBaseBar,pt); // t[eBO
	} else {
		if (bVisiblePlayBar && !bFloatingPlayBar) {
			// ȉDOCKTOOL sample 
			// f[^x[Xc[o[c[o[̉EփhbLOB
			RecalcLayout();
			CRect rect;
			m_wndPlayBar.GetWindowRect(&rect);
			rect.OffsetRect(1,0);
			DockControlBar(&m_wndDataBaseBar,(UINT)0,&rect);
		} else if (bVisibleStandBar && !bFloatingStandBar) {
			// f[^x[Xc[o[Wc[o[̉EփhbLOB
			RecalcLayout();
			CRect rect;
			m_wndStandardBar.GetWindowRect(&rect);
			rect.OffsetRect(1,0);
			DockControlBar(&m_wndDataBaseBar,(UINT)0,&rect);
		}	else {
			DockControlBar(&m_wndDataBaseBar);
		}
	}
	if (!bVisibleDataBaseBar) {
		ShowControlBar(&m_wndDataBaseBar,FALSE,FALSE);
	} 

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	CString strSection=MAINFRAME_SECTION; // Ct[L
	BOOL bDefault=FALSE;
	CRect rect; rect.SetRectEmpty();

	// XN[TCY`FbN
	int scw=theApp.GetProfileInt(strSection,CX_SCREEN,0);
	int sch=theApp.GetProfileInt(strSection,CY_SCREEN,0);
	int scWidth	=GetSystemMetrics(SM_CXSCREEN);
	int scHeight=GetSystemMetrics(SM_CYSCREEN);
	if (scw!=scWidth || sch!=scHeight)
		bDefault=TRUE;

	if (!bDefault) {
		// XN[ʒűL`FbN
		int x1=theApp.GetProfileInt(strSection,MAINFRAME_POS_X1,0);
		int y1=theApp.GetProfileInt(strSection,MAINFRAME_POS_Y1,0);
		int x2=theApp.GetProfileInt(strSection,MAINFRAME_POS_X2,0);
		int y2=theApp.GetProfileInt(strSection,MAINFRAME_POS_Y2,0);
		rect.SetRect(x1,y1,x2,y2);
		rect.NormalizeRect();
		if (rect.IsRectEmpty())
			bDefault=TRUE;
	}
	if (bDefault) {
		// l
		CPoint center(scWidth/2,scHeight/2);
		if (scWidth <= 640) {
			cs.cx=640; cs.cy=480;
			cs.x=cs.y=0;
		}
		else {
			cs.cx=800; cs.cy=600;
			cs.x=center.x-cs.cx/2;
			cs.y=center.y-cs.cy/2;
		}
	}
	// Ll
	else {
		CPoint &tl=rect.TopLeft();
		cs.cx=rect.Width();
		cs.cy=rect.Height();
		cs.x=tl.x;
		cs.y=tl.y;
	}

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

void CMainFrame::OnClose() 
{
	if (m_iCloseLock)
		return;
	CMDIFrameWnd::OnClose();// DestroyWindowĂ΂Ȃ
}

///////////
// Ct[EBhȄI
//    ̎_ŁAWindow͐ĂBftHg̒WM_DESTROY
//    bZ[WsAWindowjB
BOOL CMainFrame::DestroyWindow() 
{
	if (theApp.m_bSDocTemplateUsing) {
		theApp.m_bSDocTemplateUsing = FALSE;
	}
	

	// Ct[I_̏Ԃvt@CɋLB
	CString strSection=TOOLBAR_SECTION; // c[o[ZNV

	// Wc[o[
	// 
	BOOL bVisibleStandBar = (m_wndStandardBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_STANDBAR,bVisibleStandBar); // L
	// t[eBO
	BOOL bFloatingStandBar = m_wndStandardBar.IsFloating();
	theApp.WriteProfileInt(strSection,FLOATING_STANDBAR,bFloatingStandBar); // L
	if (bFloatingStandBar) { // t[eBOԂȂ炻̈ʒu
		CRect rect;
		m_wndStandardBar.GetWindowRect(&rect);
		CPoint &pt=rect.TopLeft();
		CSize sz(rect.Width(),rect.Height());
		CPoint &pt2=rect.BottomRight();
		theApp.WriteProfileInt(strSection,STANDBAR_POSX,pt.x);
		theApp.WriteProfileInt(strSection,STANDBAR_POSY,pt.y);
	} else {
		theApp.WriteProfileInt(strSection,STANDBAR_POSX,-1); // _~[
		theApp.WriteProfileInt(strSection,STANDBAR_POSY,-1);
	}


	// c[o[
	BOOL bVisiblePlayBar= (m_wndPlayBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	// 
	theApp.WriteProfileInt(strSection,VISIBLE_PLAYBAR,bVisiblePlayBar); // L
	// t[eBO
	BOOL bFloatingPlayBar = m_wndPlayBar.IsFloating();
	theApp.WriteProfileInt(strSection,FLOATING_PLAYBAR,bFloatingPlayBar); // L
	if (bFloatingPlayBar) { // t[eBOԂȂ炻̈ʒu
		CRect rect;
		m_wndPlayBar.GetWindowRect(&rect);
		CPoint &pt=rect.TopLeft();
		CPoint &pt2=rect.BottomRight();
		theApp.WriteProfileInt(strSection,PLAYBAR_POSX,pt.x);
		theApp.WriteProfileInt(strSection,PLAYBAR_POSY,pt.y);
	} else {
		theApp.WriteProfileInt(strSection,PLAYBAR_POSX,-1); // _~[
		theApp.WriteProfileInt(strSection,PLAYBAR_POSY,-1);
	}

	// f[^x[Xc[o[
	BOOL bVisibleDataBaseBar= (m_wndDataBaseBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	// 
	theApp.WriteProfileInt(strSection,VISIBLE_DATABASEBAR,bVisibleDataBaseBar); // L
	// t[eBO
	BOOL bFloatingDataBaseBar = m_wndDataBaseBar.IsFloating();
	theApp.WriteProfileInt(strSection,FLOATING_DATABASEBAR,bFloatingDataBaseBar); // L
	if (bFloatingDataBaseBar) { // t[eBOԂȂ炻̈ʒu
		CRect rect;
		m_wndDataBaseBar.GetWindowRect(&rect);
		CPoint &pt=rect.TopLeft();
		CPoint &pt2=rect.BottomRight();
		theApp.WriteProfileInt(strSection,DATABASEBAR_POSX,pt.x);
		theApp.WriteProfileInt(strSection,DATABASEBAR_POSY,pt.y);
	} else {
		theApp.WriteProfileInt(strSection,DATABASEBAR_POSX,-1); // _~[
		theApp.WriteProfileInt(strSection,DATABASEBAR_POSY,-1);
	}

	// Ct[L
	strSection=MAINFRAME_SECTION;

	// ő\
	int zoomed=IsZoomed();
	theApp.WriteProfileInt(strSection,MAINFRAME_MAXIMUM,zoomed);

	// XN[TCY
	int scw=GetSystemMetrics(SM_CXSCREEN);
	int sch=GetSystemMetrics(SM_CYSCREEN);
	theApp.WriteProfileInt(strSection,CX_SCREEN,scw);
	theApp.WriteProfileInt(strSection,CY_SCREEN,sch);

	// EBhEʒuTCY(XN[W)
	if (!zoomed) { // ő\ł͂ȂLB
		CRect rect;
		GetWindowRect(&rect);
		CPoint &tl=rect.TopLeft();
		CPoint &br=rect.BottomRight();
		theApp.WriteProfileInt(strSection,MAINFRAME_POS_X1,tl.x);
		theApp.WriteProfileInt(strSection,MAINFRAME_POS_Y1,tl.y);
		theApp.WriteProfileInt(strSection,MAINFRAME_POS_X2,br.x);
		theApp.WriteProfileInt(strSection,MAINFRAME_POS_Y2,br.y);
	}

	return CMDIFrameWnd::DestroyWindow();
}

void CMainFrame::OnToolsToolbar() 
{
	CToolDlg ToolDlg;

	// \`FbN
	ToolDlg.m_bStandard=((m_wndStandardBar.GetStyle() & WS_VISIBLE)!=0);
	ToolDlg.m_bPlay    =((m_wndPlayBar.GetStyle()     & WS_VISIBLE)!=0);
	ToolDlg.m_bDataBase=((m_wndDataBaseBar.GetStyle() & WS_VISIBLE)!=0);

	if (IDOK==ToolDlg.DoModal()) {
		ShowControlBar(&m_wndStandardBar, ToolDlg.m_bStandard,FALSE);
		ShowControlBar(&m_wndPlayBar,	  ToolDlg.m_bPlay,    FALSE);
		ShowControlBar(&m_wndDataBaseBar, ToolDlg.m_bDataBase,FALSE);

		m_wndStandardBar.Invalidate();
		m_wndPlayBar.Invalidate();
		m_wndDataBaseBar.Invalidate();
	}
}

//////
// I
void CMainFrame::SetCloseLock(BOOL bLock)
{
	if (bLock)
		m_iCloseLock++;
	else if (m_iCloseLock)
		m_iCloseLock--;
}

BOOL CMainFrame::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	if (LOWORD(wParam)==ID_STATUS_MESSAGE) {
		// STATUS_MESSAGE
		char *cp=(char*)lParam;
		OnStatusMessage(cp); 
		return 1;
	}

	return CMDIFrameWnd::OnCommand(wParam, lParam);
}

///////
// STATUS_MESSAGE
//  Xe[^Xo[ɃbZ[W\
void CMainFrame::OnStatusMessage(char* cp)
{
	m_wndStatusBar.SetPaneText(0,(LPCTSTR)cp);
}

////////
// EBhEċN
void CMainFrame::OnWakeUp()
{
	// EBhETopɎĂB
	// oIɈȉ̂ȂƁAJԂĎsƂ܂ȂB
	// {BringWindowToTop()ł悢Ȃ̂....B
	SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	ShowWindow(SW_SHOWNORMAL);
	SetFocus();
}

////////
// hLg̍ċNI[v
void CMainFrame::OnWakeUpOpen()
{
	// WakeUp t@CI[v
	CString FileName=theApp.GetProfileString(KF_SECTION,KF_WAKEUP_FILE,NULL);
	// CSAt@C̃`FbN
	int len=FileName.GetLength();
	char *buf=FileName.GetBuffer(len+1);
	// 啶ʂȂ
	if ((_mbsicmp((unsigned char *)&buf[len-4],(unsigned char *)".csa")==0) ||
		(_mbsicmp((unsigned char *)&buf[len-4],(unsigned char *)".pcl")==0)) { 
		// KɃhLgIăI[vB
		AfxGetApp()->OpenDocumentFile(FileName);
	}
	FileName.ReleaseBuffer();
}

///
// pbg̕ύX
void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CMDIFrameWnd::OnPaletteChanged(pFocusWnd);
	
	// p^CỸgCBׂẴr[ɑ΂čs
	BOOL bRealizePalette=FALSE;
	// ΋Ǌ
	POSITION pos = theApp.m_pMDocTemplate->GetFirstDocPosition();
	while (pos) {
		CSDJDoc *pDoc=(CSDJDoc*)theApp.m_pMDocTemplate->GetNextDoc(pos);
		POSITION pos2=pDoc->GetFirstViewPosition();
		while (pos2) {
			CSDJView *pView=(CSDJView*)pDoc->GetNextView(pos2);
			if (pView->IsKindOf(RUNTIME_CLASS(CSDJView))) {
				if (!bRealizePalette) {
					pView->OnPaletteChanged(pFocusWnd);
					bRealizePalette=TRUE; // p^CŶ͈
				}
				pView->Invalidate();
			}
		}
	}
	// l
	pos = theApp.m_pMDocTemplate2->GetFirstDocPosition();
	while (pos) {
		CSDJDoc *pDoc=(CSDJDoc*)theApp.m_pMDocTemplate2->GetNextDoc(pos);
		POSITION pos2=pDoc->GetFirstViewPosition();
		while (pos2) {
			CSDJView *pView=(CSDJView*)pDoc->GetNextView(pos2);
			if (pView->IsKindOf(RUNTIME_CLASS(CSDJView))) {
				if (!bRealizePalette) {
					pView->OnPaletteChanged(pFocusWnd);
					bRealizePalette=TRUE; // p^CŶ͈
				}
				pView->Invalidate();
			}
		}
	}
}

// caXe[^Xo[ɕ\B
void CMainFrame::OnUpdateShgdb(CCmdUI *pCmdUI)
{
	int i,j;
	pCmdUI->Enable();

	UINT id,style; int wid;
	m_wndStatusBar.GetPaneInfo(5,id,style,wid); // SHGDBCWP[^̕

	// (mw)̌vZ(蔲)
	CFont *pf=m_wndStatusBar.GetFont();
	LOGFONT lf;
	pf->GetLogFont(&lf);
	int mw=(lf.lfWidth==0)? abs(lf.lfHeight)/2: abs(lf.lfWidth);

	CString strShgdb = GetShgdbName(); // ca
	int len=strShgdb.GetLength();
	LPTSTR p=strShgdb.GetBuffer(len+1);
	if (len>0) p[len-1]='\0'; // '\'͏

	int n=strlen(p); // \̃oCg
	i=0;
	if (wid < n*mw) { // \ȂꍇB
		i=n-wid/mw;
		if (_mbsbtype((unsigned char*)p,i)==2) // QoCgڂ͖ɁB
			i++;
		// ȗsIh"..."łB
		if (i>0) {
			for (j=0;j<2;j++) { // ŏ̂Q'\'łȂ'.'ɂB
				if (p[i+j]!='\\')
					p[i+j]='.';
				else
					break;
			}
			// ŌɊ,'\'łȂ'.'ǉB
			if (_mbsbtype((unsigned char*)p,i+j)!=1) {
				if (p[i+j]!='\\')
					p[i+j]='.';
			}
		}
	}
	pCmdUI->SetText(p+i); // Xe[^Xo[ɕ\B
	strShgdb.ReleaseBuffer();
}
