// osbview.h : interface of the COSBView class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __OSBVIEW__
#define __OSBVIEW__

#include "dib.h"
#include "dibpal.h"
// Define the CreateDIBSection function.
typedef HBITMAP (APIENTRY CDSPROC)
                (HDC hDC, 
                 BITMAPINFO* pbmi,
                 UINT iUsage, 
                 VOID** ppvBits,
                 HANDLE hSection,
                 DWORD dwOffset);


class CWinSDJDoc;

class COSBView : public CScrollView
{
protected: // create from serialization only
    COSBView();
    DECLARE_DYNCREATE(COSBView)

// Attributes
public:
    CDocument* GetDocument();
    CDIB* GetDIB() {return m_pDIB;}
    CDIBPal *GetPalette() {return m_pPal;}

// Operations
public:
    BOOL Create(CDIB* pDIB);            // Create a new buffer.
    void Draw(CDC* pDC = NULL, 
              RECT* pClipRect = NULL);  // Draw off-screen buffer to screen.
    virtual void Render(CRect* pClipRect = NULL) {return;}
    void AddDirtyRegion(CRect* pRect);
    void RenderAndDrawDirtyList();

// Implementation
public:
    virtual ~COSBView();
    virtual void OnDraw(CDC* pDC);  // Overridden to draw this view.
    virtual void OnInitialUpdate(); // First time after construction.
    virtual void OnUpdate(CView* pSender,
                          LPARAM lHint,
                          CObject* pHint);


#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:
    CDIB* m_pDIB;           // The DIB buffer.
    CDIBPal* m_pPal;        // Palette for drawing.

private:
    BITMAPINFO* m_pOneToOneClrTab;  // Pointer to 1-to-1 color table
    BOOL m_bUseCreateDIBSection;    // Flag
    CDSPROC* m_pCDSProc;            // Pointer to CreateDIBSection
    HBITMAP m_hbmSection;           // Bitmap from section
    CObList m_DirtyList;            // Dirty regions
public:
    void EmptyDirtyList();

// Generated message map functions
protected:
public:
    //{{AFX_MSG(COSBView)
    afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
    afx_msg BOOL OnQueryNewPalette();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Debug version in osbview.cpp
inline CDocument* COSBView::GetDocument()
   { return (CDocument*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
#endif // __OSBVIEW__
