/*************************/
/*    SDJEditView.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "SDJEditDoc.h"
#include "SDJEditView.h"
#include <mbstring.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDJEditView

IMPLEMENT_DYNCREATE(CSDJEditView, CEditView)

BEGIN_MESSAGE_MAP(CSDJEditView, CEditView)
	//{{AFX_MSG_MAP(CSDJEditView)
	ON_COMMAND(ID_CHOOSE_FONT, OnChooseFont)
	ON_COMMAND(ID_FILL_TEXT, OnFillText)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_FILL_TEXT, OnUpdateFillText)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDJEditView NX̍\z/

CSDJEditView::CSDJEditView()
{
	// ftHgLOGFONT m_lf̐ݒ
	CString strSection=EDITOR_SECTION;
	LOGFONT lf;
	::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);
	CString strFaceName;
	CString strGothic="lr SVbN";
	// tHg̎w肪LB
	BOOL bFontValid=theApp.GetProfileInt(strSection,FONT_VALID,0);
	if (bFontValid) {
		lf.lfHeight =theApp.GetProfileInt(strSection,FONT_HEIGHT,-90);
		lf.lfWidth  =theApp.GetProfileInt(strSection,FONT_WIDTH,0);
		lf.lfWeight =theApp.GetProfileInt(strSection,FONT_WEIGHT,400);
		strFaceName =theApp.GetProfileString(strSection,FONT_FACE_NAME,strGothic);
		strcpy(lf.lfFaceName,strFaceName);  // 
	}
	else {
		lf.lfHeight	=-90; // tHg̐ݒ(9 points)
		lf.lfWidth	=0;   // tHg͎ݒ
		lf.lfWeight =400; // Wl
		strcpy(lf.lfFaceName,strGothic); // 
	}
	lf.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	lf.lfQuality		= DEFAULT_QUALITY;
	lf.lfPitchAndFamily = DEFAULT_PITCH;

	CFont ft;
	if (bFontValid) {
		if (ft.CreateFontIndirect(&lf)) {
			ft.GetLogFont(&m_lf);
		}
		else
			m_lf=lf;
	}
	else {
		if (ft.CreatePointFontIndirect(&lf)) {
			ft.GetLogFont(&m_lf);
		}
		else
			m_lf=lf;
	}
}

CSDJEditView::~CSDJEditView()
{
}

BOOL CSDJEditView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// [h bvgp\ɂ܂

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CSDJEditView NX̕`

void CSDJEditView::OnDraw(CDC* pDC)
{
	CSDJEditDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}

/////////////////////////////////////////////////////////////////////////////
// CSDJEditView NẌ

BOOL CSDJEditView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg CEditView ̈
	return CEditView::OnPreparePrinting(pInfo);
}

void CSDJEditView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// ftHg CEditView ňJn܂B
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CSDJEditView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// ftHg CEditView ̈̌㏈
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CSDJEditView NX̐ff

#ifdef _DEBUG
void CSDJEditView::AssertValid() const
{
	CEditView::AssertValid();
}

void CSDJEditView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CSDJEditDoc* CSDJEditView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDJEditDoc)));
	return (CSDJEditDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSDJEditView NX̃bZ[W nh

void CSDJEditView::OnInitialUpdate() 
{
	CEditView::OnInitialUpdate();
	
	// tHg̐ݒ
	m_font.DeleteObject();
	if (m_font.CreateFontIndirect(&m_lf)) {
		SetFont(&m_font);
	}
	// Undoobt@̏
	m_strUndoFill.Empty();
}

/////
// tHg̐ݒ
void CSDJEditView::OnChooseFont() 
{
   CFont* pft = GetFont();
   LOGFONT lf;
   if (pft != NULL)
	   pft->GetObject(sizeof(LOGFONT), &lf);
   else
	   ::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);

	CFontDialog dlg(&lf, CF_SCREENFONTS|
						 CF_INITTOLOGFONTSTRUCT|
						 CF_FIXEDPITCHONLY);

	if (dlg.DoModal() == IDOK) {
		m_font.DeleteObject();
		lf.lfOutPrecision	= m_lf.lfOutPrecision;
		lf.lfClipPrecision	= m_lf.lfClipPrecision;
		lf.lfQuality		= m_lf.lfQuality;
		lf.lfPitchAndFamily = m_lf.lfPitchAndFamily;
		if (m_font.CreateFontIndirect(&lf)) {
			SetFont(&m_font);
			m_lf = lf;
		}
	}
}

/////
// ǂl
void CSDJEditView::OnUpdateFillText(CCmdUI* pCmdUI) 
{
	CString str;
	GetWindowText(str);
	if (str.GetLength())
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}
void CSDJEditView::OnFillText() 
{
	// s߂(pZ)
	CFont *pFont=GetFont();
	if (pFont==NULL)
		return;
	LOGFONT lf;
	pFont->GetLogFont(&lf);
	int w=(lf.lfWidth)? abs(lf.lfWidth):(abs(lf.lfHeight)+1)/2;
	CRect rc;
	GetClientRect(&rc);
	int nline=rc.Width()/w; // s̕(pZ)
	if (nline<2)
		return;

	CString str1;
	GetWindowText(str1); // {eLXg
	LPCTSTR p1 =str1;
	int len1=str1.GetLength();

	CString str2;		 // [NeLXg
	LPTSTR p2=str2.GetBuffer(len1+1);
	memset(p2,0,len1+1); // 0 clear
	// 悸As͂̂܂܂\r\n菜(str2)
	while ((*p1)!='\0') {
		if ((*p1)!='\r') {
			*p2=*p1; p1++; p2++;
		}
		else {
			if ((*(p1+2))=='\r') { // sɌqĂA
				while((*p1)=='\r' || (*p1)=='\n') {
					*p2=*p1; p1++; p2++; // sR[hRs[
				}
			}
			else {
				p1+=2; // sR[h͏
			}
		}
	}
	str2.ReleaseBuffer();

	// str2{eLXg
	p1=str2;
	CString str3; // ړĨeLXg
	CString strline;	// s
	p2=strline.GetBuffer(nline+3);
	memset(p2,0,nline+3); // 0 clear
	int n=0; // PsJE^
	// {eLXg̏I[܂ŌJԂ
	while((*p1)!='\0') {
		if ((*p1)=='\r') { // sR[hȂ
			*p2=*p1; p1++; p2++; // ̂܂܃Rs[B
			*p2=*p1; p1++;
			strline.ReleaseBuffer();
			str3 += strline; // sfoāAsobt@B
			p2=strline.GetBuffer(nline+3);
			memset(p2,0,nline+3);
			n=0;
			continue; // p
		}
		if (n < nline) {  // sobt@tɂȂĂȂ΁A
			*p2=*p1; p1++; p2++; n++;  // ɍsobt@֑}
			continue; // p
		}
		if (n==nline) {  // sobt@tɂȂA
			if (_mbsbtype((unsigned char *)(LPCTSTR)strline,n-1)==1) {
				// PoCgڂȂA̕sB
				p2--;
				*p2='\r'; p2++;
				*p2='\n';
				strline.ReleaseBuffer();
				str3 += strline; // sfoāAsobt@B
				p2=strline.GetBuffer(nline+3);
				memset(p2,0,nline+3);
				n=0;
				p1--;
				*p2=*p1; p1++; p2++; n++; // PoCgڂ{s֕
			    *p2=*p1; p1++; p2++; n++; // QoCgڂ̎ɑ}
			}
			else { // PoCgڂłȂ΁AsB
				*p2='\r'; p2++;
				*p2='\n';
				strline.ReleaseBuffer();
				str3 += strline; // sfoāAsobt@B
				p2=strline.GetBuffer(nline+3);
				memset(p2,0,nline+3);
				n=0;
			    *p2=*p1; p1++; p2++; n++; // ̕s֑}
			}
		}
	} 	// {eLXg̏I[܂ŌJԂ
	// ŏIsfoāAړĨeLXgB
	strline.ReleaseBuffer();
	str3 += strline;

	SetWindowText(str3); // VKeLXg
	m_strUndoFill=str1;  // eLXg
	GetDocument()->SetModifiedFlag(TRUE);
}

////
// Undo
void CSDJEditView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	CEdit &ed=GetEditCtrl();

	BOOL bCanUndo=ed.CanUndo();

	if (bCanUndo) { 
		// GfBbgRg[UndoLɂȂ
		// ǂl߂Undo͖ɂB
		if (!m_strUndoFill.IsEmpty()) {
			m_strUndoFill.Empty();
		}
	}
	
	BOOL bEnable= bCanUndo | !m_strUndoFill.IsEmpty();

	pCmdUI->Enable(bEnable);
}
void CSDJEditView::OnEditUndo() 
{
	CEdit &ed=GetEditCtrl();

	if (ed.CanUndo()) {
		ed.Undo();
	}
	else {
		if (!m_strUndoFill.IsEmpty()) {
			CString str;
			GetWindowText(str);
			SetWindowText(m_strUndoFill);
			m_strUndoFill=str; // ̃eLXgUndoobt@ցB
		}
	}
}


void CSDJEditView::OnDestroy() 
{
	CEditView::OnDestroy();
	
	// tHginit@CL
	CString strSection=EDITOR_SECTION;

	theApp.WriteProfileInt(strSection,FONT_HEIGHT,m_lf.lfHeight);
	theApp.WriteProfileInt(strSection,FONT_WIDTH,m_lf.lfWidth);
	theApp.WriteProfileInt(strSection,FONT_WEIGHT,m_lf.lfWeight);
	CString strFaceName=m_lf.lfFaceName;
	theApp.WriteProfileString(strSection,FONT_FACE_NAME,strFaceName);
	theApp.WriteProfileInt(strSection,FONT_VALID,1);
}
