/***********************/
/*    StatusBox.cpp    */
/***********************/
#include "stdafx.h"
// IDD_STATUSBOX,IDC_STATUSLIST,IDC_JOB_STOP,ID_PRINT_MESSAGE
// resource.hincludeB
#include "winsdj.h"
#include "StatusBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ő5000s܂ŕێB(Â̂폜)
#define STATUS_BOX_MAX_COUNT 5000

/////////////////////////////////////////////////////////////////////////////
// CStatusBox _CAO

void CStatusBox::common_init()
{
	//{{AFX_DATA_INIT(CStatusBox)
	//}}AFX_DATA_INIT

	m_bJobWorking=FALSE;
	m_pWorkerThread=NULL;
	m_lThreadParam=0L;
}

CStatusBox::CStatusBox(CWnd* pParent /*=NULL*/)
	: CDialog(CStatusBox::IDD, pParent)
{
	common_init();
}

CStatusBox::CStatusBox(UINT (*pWorkerThread)(CStatusBox *,CEvent*,LPARAM),LPARAM lParam,CWnd* pParent): CDialog(CStatusBox::IDD, pParent)
{
	common_init();
	m_lThreadParam=lParam;
	SetWorkerThread(pWorkerThread);
}

void CStatusBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatusBox)
	DDX_Control(pDX, IDC_STATUSLIST, m_StatusList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStatusBox, CDialog)
	//{{AFX_MSG_MAP(CStatusBox)
	ON_BN_CLICKED(IDC_JOB_STOP, OnJobStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatusBox bZ[W nh

// s\ Xbh֐
static UINT StatusBoxWorkerThread(LPVOID pParam)
{
	CStatusBox  *pBox=(CStatusBox *)pParam;
	CEvent *pStopEvent=pBox->GetStopEvent();
	LPARAM lParam=pBox->GetThreadParam();
	ASSERT(pBox->m_pWorkerThread);

	pBox->EnableStatusStop(); // ft Enable

	UINT ret=pBox->m_pWorkerThread(pBox,pStopEvent,lParam);// ƃXbh[`

	pBox->DisableStatusStop(); // ft Disable

	return ret;
}

// _CAO{bNX̏
BOOL CStatusBox::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Xg{bNX̃tHgTCY̎擾
	CDC *pDC=m_StatusList.GetDC();
	CFont *pFont=pDC->GetCurrentFont();
	LOGFONT lf;
	pFont->GetObject(sizeof(LOGFONT),&lf);
	CSize Size(lf.lfWidth,lf.lfHeight);
	if (Size.cx==0) Size.cx=Size.cy/2;
	pDC->LPtoDP(&Size); // sNZɕϊ
    ReleaseDC(pDC);

	m_lfWidth=Size.cx;

	// \Xg{bNX̃NA
	m_StatusList.ResetContent();
	// Xg{bNX
	m_Width=m_StatusList.GetHorizontalExtent();
	// \Xbh̋N(D揇ʂ͂Pi)
	CWinThread *pStatusBoxThread=AfxBeginThread(StatusBoxWorkerThread,
		this,THREAD_PRIORITY_BELOW_NORMAL);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// ft Enable
void CStatusBox::EnableStatusStop(void)
{
	m_bJobWorking=TRUE;
}

// ft Disable
void CStatusBox::DisableStatusStop(void)
{
	m_bJobWorking=FALSE;
}

// Xg{bNXɕ\
void CStatusBox::PrintMessage(LPTSTR pMessage)
{
	int iCount=m_StatusList.GetCount();  // s

	if (iCount==STATUS_BOX_MAX_COUNT) {  // I[o[t[
		m_StatusList.DeleteString(0);    // 擪ڂ폜
		iCount--;
	}

	// ̑}
	m_StatusList.InsertString(-1,pMessage);
	iCount++;

	// J[\֎Ă䂭
	m_StatusList.SetCurSel(iCount-1);

	// _CAO{bNX̌vZ
	int len=strlen(pMessage);
    int width=m_lfWidth*len;
	if (width > m_Width) {
		m_StatusList.SetHorizontalExtent(width);
		m_Width=width;
	}
}

// bZ[WR}h
BOOL CStatusBox::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (LOWORD(wParam)==ID_PRINT_MESSAGE) {
		// PRINT_MESSAGE
		LPTSTR pMessage=(LPTSTR)lParam;
		PrintMessage(pMessage); // Xg{bNX\
		return 1;
	}
	else
		return CDialog::OnCommand(wParam, lParam);
}

// 
void CStatusBox::OnCancel() 
{
	if (!m_bJobWorking)
		CDialog::OnCancel();
}

// sf
void CStatusBox::OnJobStop() 
{
	if (m_bJobWorking)
		m_StopEvent.SetEvent();
}
