/* 
 *  Modified by Ra 1993.6 
 */
#pragma warning(disable:4996)

#include    <setjmp.h>
#include    <reexp.h>

/* Modified by Ra 1993.6 */
#define malloc  memalloc
#define free    memfree
void *memalloc(unsigned int);
void memfree(void *);

#define CODEMAX 256
#define tolower(x)  ((((x)>='a')&&((x)<='z')) ? ((x)-'a'+'A') : (x))
#define CurrChar (*CurrCharFunc)
#define NextChar (*NextCharFunc)
#define PrevChar (*PrevCharFunc)

Local RePat     *NewPat;
Local Int       MaxBlock;
Local Kanji     Ch;
Local Char      *PatString;
Local Bool      FirstPosition;
Local jmp_buf   JumpEnv;
Local RePat     *cpattern  = NULL;
Local char      *ErrMes[2] = {"No previous regular expression",
                             "Out of memory"};
Local RePat *CurrPat;
Local Char  *CurrBuf;
Local Char  *SepCh =(Char*) "\b\n\t\f .,!\"#$%&'()=`|~@[]{}<>-+*/?_\\";
Local Int   Bits;
Local Kanji (*CurrCharFunc)() = NULL;
Local Kanji (*NextCharFunc)() = NULL;
Local Kanji (*PrevCharFunc)() = NULL;
Local Char  Seps[CODEMAX];
Local Bool  SepInited = FALSE;
Local Bool re_ignore_case = FALSE;

/*
 *	1988.10/15 (serow):changes for some C compilers
 */
Local void
FreeClassList(Clist)
Class   *Clist;
{
    if ( !Clist ) {
        return;
    }
    FreeClassList(NextClass(Clist));
    free(Clist);
    return;
}

Local void
FreeNode(Token, clist)	/* 1988.10/15 serow */
Pat     *Token;
int      clist;	/* 1988.10/15 serow */
{
    if ( !Token ) {
        return;
    }
    switch( TokenType(Token) ) {
    case CCL:
    case NCCL:
	   if (clist)	/* 1988.10/15 serow */
		   FreeClassList(ClassList(Token));
	break;
    }
    FreeNode(NextToken(Token), clist);	/* 1988.10/15 serow */
    free(Token);
    return;
}

Local void
refree(OldPat)
RePat   *OldPat;
{
    Reg int     i;
    
    for( i = 0; i<10; i++ ) {
        if ( MatchPattern(OldPat,i,0) ) {
	    FreeNode(MatchPattern(OldPat,i,0), 0);	/* 1988.10/15 serow */
	    FreeNode(MatchPattern(OldPat,i,1), 1);	/* 1988.10/15 serow */
	}
    }
    free(OldPat);
    return;
}

Local Kanji
GetChar()
{
    if ( ! *PatString ) {
        Ch = NULL;
        return(NULL);
    }
    Ch = *PatString++;
    if ( iskanji(Ch) ) {
        Ch = (Ch<<8) + *PatString++;
	return(Ch);
    }
    return(Ch);
}

Local Char
DecideMode()
{
    switch( Ch ) {
    case RE_CL1:
        GetChar();
	return(CLOSURE1);
	break;
    case RE_CL2:
        GetChar();
	return(CLOSURE2);
	break;
    case RE_CL3:
        GetChar();
	return(CLOSURE3);
    }
    return(NULL);
}

Local Pat*
MakeToken(Request)
Char    Request;
{
    Reg Pat     *NewToken;
    
    if ( (NewToken = (Pat *)malloc(sizeof(Pat))) == NULL ) {
        longjmp(JumpEnv,-1);
    }
    TokenType(NewToken) = Request;
    NextToken(NewToken) = NULL;
    TokenMode(NewToken) = NULL;
    return( NewToken );
}

Local Kanji
GetHex()
{
    Reg Kanji   Data = 0;
    
    while( ishexa(Ch) ) {
        Data = Data * 16 + htoi(Ch);
	GetChar();
    }
    return(Data);
}

Local Kanji
GetOctal()
{
    Reg Kanji   Data = 0;
    
    while( isoctal(Ch) ) {
        Data = Data * 8 + otoi(Ch);
	GetChar();
    }
    return(Data);
}

Local Kanji
GetEscChar()
{
    Reg Kanji   Old = Ch;
    
    GetChar();
    switch(Old) {
    case 'n':
        return('\n');
    case 't':
        return('\t');
    case 'f':
        return('\f');
    case 'b':
        return('\b');
    case '0':
	if ( Ch == 'x' ) {
	    GetChar();
            return( GetHex() );
        } else if ( isoctal(Ch) ) {
            return( GetOctal() );
	} else {
            return(0);
	}
	break;
    default:
        return(Old);
    }
}

Local Class*
MakeClass(Start,Stop)
Kanji   Start;
Kanji   Stop;
{
    Reg Class   *NewClass;
    
    if ( (NewClass = (Class *)malloc(sizeof(Class))) == NULL ) {
        longjmp(JumpEnv,-1);
    }
    ClassStart(NewClass) = min(Start,Stop);
    ClassEnd(NewClass) = max(Start,Stop);
    NextClass(NewClass) = NULL;
    return(NewClass);
}

Local Class*
MakeClassList()
{
    Reg Class   *Ccl;
    Reg Kanji   Nc1;
    Reg Kanji   Nc2;
    Reg enum {First,Middle,Second} Proc = First;
    
    while( TRUE ) {
        switch( Ch ) {
        case RE_ESC:
	    switch( Proc ) {
	    case First:
                GetChar();
	        Nc1 = GetEscChar();
		if ( Nc1 ) {
		    Proc = Middle;
		}
		break;
	    case Middle:
	        Nc2 = Nc1;
		goto GotOne;
		break;
	    case Second:
	        GetChar();
		Nc2 = GetEscChar();
		if ( Nc2 ) {
		    goto GotOne;
		}
	    }
	    break;
        case RE_CEND:
            switch( Proc ) {
	    case First:
	    case Second:
	        GetChar();
                return(NULL);
		break;
	    case Middle:
	        Nc2 = Nc1;
		goto GotOne;
		break;
	    }
            break;
	case NULL:
            return(NULL);
	    break;
	case RE_RNG:
            GetChar();
	    switch( Proc ) {
	    case First:
	    case Second:
	        Proc = First;
		break;
	    case Middle:
	        Proc = Second;
		break;
	    }
	    break;
	default:
	    switch( Proc ) {
	    case First:
	        Nc1 = Ch;
		GetChar();
		Proc = Middle;
		break;
	    case Middle:
	        Nc2 = Nc1;
		goto GotOne;
		break;
	    case Second:
	        Nc2 = Ch;
		GetChar();
		goto GotOne;
	    }
	}
    }
  GotOne:
    Ccl = MakeClass(Nc1,Nc2);
    NextClass(Ccl) = MakeClassList();
    return(Ccl);
}

Local Pat*
UsualToken()
{
    Reg Pat     *Token;
    
    Token = MakeToken(LIT);
    LiteralChar(Token) = Ch;
    GetChar();
    TokenMode(Token) = DecideMode();
    return(Token);
}
    
Local Pat*
Parse()
{
    Reg Pat     *Token;

  BadOne:
    switch(Ch) {
    case NULL:
        return(NULL);
	break;
    case RE_ANY:
        Token = MakeToken(ANY);
        GetChar();
	TokenMode(Token) = DecideMode();
	break;
    case RE_BOL:
        if ( FirstPosition ) {
            Token = MakeToken(BOL);
            GetChar();
        } else {
	    Token = UsualToken();
	}
	break;
    case RE_EOL:
        if ( ! *PatString ) {
            Token = MakeToken(EOL);
            GetChar();
	} else {
	    Token = UsualToken();
	}
        break;
    case RE_ESC:
        GetChar();
	switch(Ch) {
        case RE_OR:
            Token = MakeToken(OR);
	    GetChar();
	    break;
	case RE_BOW:
            Token = MakeToken(BOW);
            GetChar();
	    break;
	case RE_EOW:
            Token = MakeToken(EOW);
            GetChar();
	    break;
	case RE_BOB:
            FirstPosition = FALSE;
            MaxBlock++;
            if ( MaxBlock > 9 ) {
                return(NULL);
            }
            Token = MakeToken(BLOCK);
            BlockNo(Token) = MaxBlock;
            GetChar();
            MatchPattern(NewPat,BlockNo(Token),1) = Parse();
            GetChar();
            TokenMode(Token) = DecideMode();
            break;
        case RE_EOB:
	case NULL:
	    return(NULL);
        case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	    Token = MakeToken(BLREF);
	    BlockNo(Token) = otoi(Ch);
	    GetChar();
	    TokenMode(Token) = DecideMode();
	    break;
        default:
            Token = MakeToken(LIT);
            LiteralChar(Token) = GetEscChar();
	    if ( !LiteralChar(Token) ) {
	        free(Token);
		goto BadOne;
	    }
	    TokenMode(Token) = DecideMode();
	}
        break;
    case RE_CCL:
        GetChar();
	if ( Ch == RE_NCCL ) {
	    Token = MakeToken(NCCL);
            GetChar();
        } else {
            Token = MakeToken(CCL);
	}
        ClassList(Token) = MakeClassList();
	TokenMode(Token) = DecideMode();
        break;
    default:
        Token = UsualToken();
    }
    FirstPosition = FALSE;
    NextToken(Token) = Parse();
    return(Token);
}

Local Pat*
RevToken(Token)
Reg Pat *Token;
{
    Reg Pat     *Result;
    Reg Pat     *NewToken;
    Reg Pat     *CurrToken;
    
    if ( !Token ) {
        return(NULL);
    }
    CurrToken = Result = RevToken(NextToken(Token));
    if ( (NewToken = (Pat *)malloc(sizeof(Pat))) == NULL ) {
        longjmp(JumpEnv,-1);
    }
    *NewToken = *Token;
    NextToken(NewToken) = NULL;
    while( CurrToken ) {
        if ( !NextToken(CurrToken) ) {
	    NextToken(CurrToken) = NewToken;
	    return(Result);
	}
	CurrToken = NextToken(CurrToken);
    }
    return(NewToken);
}

Local void
ReversePattern()
{
    Reg Int     Count;
    
    for( Count=0; Count<10; Count++ ) {
        if ( MatchPattern(NewPat,Count,1) ) {
            MatchPattern(NewPat,Count,0) =
	        RevToken(MatchPattern(NewPat,Count,1));
	}
    }
    return;
}
	    
Local void
InitVars()
{
    if ( (NewPat = (RePat *)malloc(sizeof(RePat)) ) == NULL ) {
        longjmp(JumpEnv,-1);
    }
    BitsMap(NewPat) = NULL;
    for( MaxBlock=0; MaxBlock<10; MaxBlock++ ) {
        MatchPattern(NewPat,MaxBlock,0) = NULL;
	MatchPattern(NewPat,MaxBlock,1) = NULL;
	MatchBegin(NewPat,MaxBlock) = 0;
	MatchEnd(NewPat,MaxBlock) = 0;
    }
    MaxBlock = 0;
    FirstPosition = TRUE;
    return;
}

Local RePat*
recomp(String)
Char    *String;
{
    PatString = String;
    if ( setjmp(JumpEnv) != 0 ) {
        return(NULL);
    }
    InitVars();
    GetChar();
    MatchPattern(NewPat,0,1) = Parse();
    ReversePattern();
    return(NewPat);
}


Local Bool
iseq(C1,C2)
Kanji   C1;
Kanji   C2;
{
    if ( re_ignore_case ) {
        return( (tolower(C1) == tolower(C2)) );
    } else {
        return( (C1 == C2) );
    }
}

Local void
SepInit(String)
Char    *String;
{
    Reg Int     I;
    
    if ( !String ) {
        String = SepCh;
    }
    for( I=0; I<CODEMAX; I++ ) {
        Seps[I] = 0;
    }
    while( *String ) {
        Seps[*String] = 1;
	String++;
    }
    SepInited = TRUE;
    return;
}

Local Bool
IsSep(C)
Kanji   C;
{
    if ( !C || C >= CODEMAX ) {
        return(TRUE);
    } else {
        return( (Bool)Seps[C] );
    }
}

Local Bool
WithIn(C,Clist)
Kanji   C;
Class   *Clist;
{
    if ( !Clist ) {
        return(FALSE);
    }
    if ( re_ignore_case ) {
        Kanji   Cs = ClassStart(Clist);
	Kanji   Ce = ClassEnd(Clist);
        if ( (tolower(C) >= tolower(Cs)) && (tolower(C) <= tolower(Ce)) ) {
	     return(TRUE);
        }
    } else {
        if ( (C >= ClassStart(Clist)) && (C <= ClassEnd(Clist)) ) {
            return(TRUE);
	}
    }
    return( WithIn(C,NextClass(Clist)) );
}

Local Kanji
DefaultCurrChar(Pos)
Int     Pos;
{
    Reg Kanji   C;
    
    if ( Pos < 0 ) {
        return(NULL);
    }
    if ( iskanji(CurrBuf[Pos]) ) {
        C = (CurrBuf[Pos] << 8) + CurrBuf[Pos+1];
    } else {
        C = CurrBuf[Pos];
    }
    return(C);
}

Local Kanji
DefaultNextChar(Pos,NextPos)
Int     Pos;
Int     *NextPos;
{
    if ( Pos < 0 ) {
        *NextPos = 0;
    } else {
        if ( iskanji(CurrBuf[Pos]) ) {
            *NextPos = Pos + 2;
        } else {
            *NextPos = Pos + 1;
        }
    }
    return( CurrChar(*NextPos) );
}

Local Kanji
DefaultPrevChar(Pos,PrevPos)
Int     Pos;
Int     *PrevPos;
{
    Reg Int     Work = 0;
    
    if ( !Pos ) {
        *PrevPos = -1;
	return(NULL);
    }
    while( Work < Pos ) {
        *PrevPos = Work;
	if ( iskanji(CurrBuf[Work]) ) {
	    Work += 2;
	} else {
	    Work++;
	}
    }
    return( CurrChar(*PrevPos) );
}

Local Bool
TagMatch(No,Start,End,D)
Char    No;
Int     Start;
Int     *End;
Bool    D;
{
    Reg Int     BufStart = MatchBegin(CurrPat,No);
    Reg Int     BufEnd = MatchEnd(CurrPat,No);
    
    if ( !(Bits & (1 << No)) || (BufStart == BufEnd) ) {
        return(FALSE);
    }
    if ( D ) {
        while( BufStart < BufEnd ) {
            if ( !CurrChar(Start) ) {
	        return(FALSE);
            }
            if ( !iseq(CurrChar(Start),CurrChar(BufStart)) ) {
                return(FALSE);
            }
            BufStart++;
            Start++;
        }
	*End = Start;
    } else {
        while( BufEnd < BufStart ) {
	    if ( !CurrChar(Start) ) {
	        return(FALSE);
	    }
	    if ( !iseq(CurrChar(Start),CurrChar(BufStart)) ) {
	        return(FALSE);
	    }
	    BufStart--;
	    Start--;
        }
        Start++;
	PrevChar(Start,End);
    }
    return(TRUE);
}

Local void
MovePosition(Start,End,D)
Int     Start;
Int     *End;
Int     D;
{
    if ( D ) {
        NextChar(Start,End);
    } else {
        PrevChar(Start,End);
    }
    return;
}

Local Bool
SelectMatch(Token,Start,End,Direction)
Pat     *Token;
Int     Start;
Int     *End;
Bool    Direction;
{
    Bool  MatchRest();
    
    if ( !Token || (TokenType(Token) == OR) ) {
        return(FALSE);
    }
    while( !MatchRest(Token,Start,End,Direction) ) {
        while( Token && (TokenType(Token) != OR) ) {
	    Token = NextToken(Token);
	}
	if ( !Token || !NextToken(Token) ) {
	    return(FALSE);
	}
	Token = NextToken(Token);
    }
    return(TRUE);
}

Local Bool
MatchOne(Token,Start,End,D)
Pat     *Token;
Int     Start;
Int     *End;
Int     D;
{
    Kanji       C = CurrChar(Start);
    Int         BitsSave = Bits;
    Bool        MatchRest();

    switch( TokenType(Token) ) {
    case ANY:
        if ( !iseol(C) ) {
	    MovePosition(Start,End,D);
	} else {
	    goto MatchFail;
	}
        break;
    case LIT:
        if ( iseq(C,LiteralChar(Token)) ) {
	    MovePosition(Start,End,D);
	} else {
	    goto MatchFail;
	}
        break;
    case CCL:
        if ( WithIn(C,ClassList(Token)) ) {
	    MovePosition(Start,End,D);
	} else {
	    goto MatchFail;
	}
	break;
    case NCCL:
        if ( C && !WithIn(C,ClassList(Token)) ) {
	    MovePosition(Start,End,D);
	} else {
	    goto MatchFail;
	}
	break;
    case BLOCK:
        if ( SelectMatch(MatchPattern(CurrPat,BlockNo(Token),D),Start,End,D) ) {
	    MatchBegin(CurrPat,BlockNo(Token)) = Start;
	    MatchEnd(CurrPat,BlockNo(Token)) = *End;
            Bits |= (1 << BlockNo(Token));
        } else {
	    goto MatchFail;
	}
	break;
    case BLREF:
        if ( !TagMatch(BlockNo(Token),Start,End,D) ) {
	    goto MatchFail;
	}
	break;
    default:
        goto MatchFail;
    }
    return(TRUE);
  MatchFail:
    Bits = BitsSave;
    return(FALSE);
}

Local Bool
MatchClosure1(Token,Start,End,Direction)
Pat     *Token;
Int     Start;
Int     *End;
Int     Direction;
{
    Bool    MatchRest();
    Int     BitsSave = Bits;
    
    if ( !MatchOne(Token,Start,End,Direction) ) {
        return( MatchRest(NextToken(Token),Start,End,Direction) );
    } else {
        if ( MatchClosure1(Token,*End,End,Direction) ) {
	    return(TRUE);
	} else {
	    Bits = BitsSave;
            return( MatchRest(NextToken(Token),Start,End,Direction) );
	}
    }
}

Local Bool
MatchClosure2(Token,Start,End,Direction)
Pat     *Token;
Int     Start;
Int     *End;
Int     Direction;
{
    Int     BitsSave = Bits;
    
    if ( !MatchOne(Token,Start,End,Direction) ) {
        return(FALSE);
    } else {
        if ( MatchClosure1(Token,*End,End,Direction) ) {
            return(TRUE);
        } else {
            Bits = BitsSave;
	    return(FALSE);
	}
    }
}

Local Bool
MatchClosure3(Token,Start,End,Direction)
Pat     *Token;
Int     Start;
Int     *End;
Int     Direction;
{
    Bool    MatchRest();
    
    if ( MatchOne(Token,Start,End,Direction) ) {
        return( MatchRest(NextToken(Token),*End,End,Direction) );
    } else {
        return( MatchRest(NextToken(Token),Start,End,Direction) );
    }
}

Local Bool
MatchRest(Token,Start,End,Direction)
Pat     *Token;
Int     Start;
Int     *End;
Int     Direction;
{
    Int     BitsSave = Bits;
    
    if ( !Token ) {
        *End = Start;
	return(TRUE);
    }
    switch( TokenType(Token) ) {
    case BOL:
        if ( Direction ) {
            if ( !iseol(PrevChar(Start,End)) ) {
                return(FALSE);
	    }
	} else {
	    if ( !iseol(CurrChar(Start)) ) {
	        return(FALSE);
	    }
	}
	break;
    case BOW:
        if ( Direction ) {
            if ( !(!IsSep(CurrChar(Start)) && IsSep(PrevChar(Start,End))) ) {
	        return(FALSE);
	    }
	} else {
	    if ( !(IsSep(CurrChar(Start)) && !IsSep(NextChar(Start,End))) ) {
	        return(FALSE);
	    }
	}
	break;
    case EOL:
        if ( Direction ) {
            if ( !iseol(CurrChar(Start)) ) {
	        return(FALSE);
	    }
	} else {
	    if ( !iseol(NextChar(Start,End)) ) {
	        return(FALSE);
	    }
	}
	break;
    case EOW:
        if ( Direction ) {
            if ( !(IsSep(CurrChar(Start)) && !IsSep(PrevChar(Start,End))) ) {
	        return(FALSE);
	    }
	} else {
	    if ( !(!IsSep(CurrChar(Start)) && IsSep(NextChar(Start,End))) ) {
	        return(FALSE);
	    }
	}
	break;
    case OR:
        *End = Start;
        return(TRUE);
    default:
        switch( TokenMode(Token) ) {
	case CLOSURE1:
	    return( MatchClosure1(Token,Start,End,Direction) );
	case CLOSURE2:
	    return( MatchClosure2(Token,Start,End,Direction) );
	case CLOSURE3:
	    return( MatchClosure3(Token,Start,End,Direction) );
	default:
	    if ( MatchOne(Token,Start,End,Direction) ) {
		Start = *End;
	    } else {
	        return(FALSE);
	    }
	}
    }
    if ( MatchRest(NextToken(Token),Start,End,Direction) ) {
        return(TRUE);
    } else {
        Bits = BitsSave;
        return(FALSE);
    }
}

Local Bool
MatchGo(StartPos,Direction)
Int     StartPos;
Int     Direction;
{
    Pat         *Token = MatchPattern(CurrPat,0,Direction);
    Int         End;
    
    while( TRUE ) {
        Bits = NULL;
        if ( !CurrChar(StartPos) ) {
	    return(FALSE);
	}
        if ( SelectMatch(Token,StartPos,&End,Direction) ) {
	    Bits |= 1;
	    MatchBegin(CurrPat,0) = StartPos;
	    MatchEnd(CurrPat,0) = End;
            return(TRUE);
        }
        if ( TokenType(Token)==BOL && !StartPos) {
	    return(FALSE);
	}
	MovePosition(StartPos,&StartPos,Direction);
    }
}

/* Modified by Ra 1993.6 */
/*
Local void
ModifyResult(P)
RePat   *P;
{
    Reg Int     Count;
    Int         Work;
    
    for( Count=0; Count<10; Count++ ) {
        if ( IsSuccess(P,Count) ) {
            NextChar(MatchBegin(P,Count),&Work);
            NextChar(MatchEnd(P,Count),&MatchBegin(P,Count));
	    MatchEnd(P,Count) = Work;
	}
    }
    return;
}
*/

Local void
re_init_func(Curr,Prev,Next)
Kanji   (*Curr)();
Kanji   (*Prev)();
Kanji   (*Next)();
{
    if ( !SepInited ) {
        SepInit(NULL);
    }
    if ( !Curr && !CurrCharFunc ) {
        CurrCharFunc = DefaultCurrChar;
	NextCharFunc = DefaultNextChar;
	PrevCharFunc = DefaultPrevChar;
    } else if ( Curr ) {
        CurrCharFunc = Curr;
        NextCharFunc = Next;
        PrevCharFunc = Prev;
    }
    return;
}
            
Local Bool
re_search_forward(Pattern,String,StartPos)
RePat   *Pattern;
Char    *String;
Int     StartPos;
{
    re_init_func(NULL,NULL,NULL);
    CurrBuf = String;
    CurrPat = Pattern;
    if (  MatchGo(StartPos,1) ) {
        BitsMap(Pattern) = Bits;
	return(TRUE);
    } else {
        BitsMap(Pattern) = NULL;
        return(FALSE);
    }
}

char    *
re_comp(pattern)
char    *pattern;
{
    re_init_func(NULL,NULL,NULL);
    
    if ( !pattern || !(*pattern) ) {
        if ( !cpattern ) {
	    return(ErrMes[0]);
	}
    } else {
        if ( cpattern ) {
	    refree(cpattern);
	}
	cpattern = recomp(pattern);
	if ( !cpattern ) {
	    return(ErrMes[1]);
	}
    }
    return(NULL);
}

int
re_exec(line)
char    *line;
{
    if ( !cpattern ) {
        return(0);
    }
    return( re_search_forward(cpattern,line,0) );
}
