#ifndef NULL
#define NULL    0
#endif

#define TRUE    (1)
#define FALSE   (0)
#define Local	static
#define	Reg	register

typedef unsigned short int
    Kanji;
typedef unsigned char
    Char;
typedef int
    Bool;
typedef /* unsigned */ int
    Int;
typedef struct _cls {
    Kanji   Start;
    Kanji   End;
    struct _cls *Next;
}   Class;
typedef struct _pat {
    Char    Type;
    Char    Mode;
    struct _pat *Next;
    union   {
        Kanji   Lit;
	Class   *Clist;
	Int     RefNo;
    }   Code;
}   Pat;
typedef struct {
    Int     Bits;
    Int     Begin[10];
    Int     End[10];
    Pat     *PatPtr[2][10];
}   RePat;

#define BitsMap(x)          ((x)->Bits)
#define MatchBegin(x,y)     ((x)->Begin[(y)])
#define MatchEnd(x,y)       ((x)->End[(y)])
#define MatchPattern(x,y,d) ((x)->PatPtr[(d)][(y)])

#define BeginOfMatch(x,y)   MatchBegin(x,y)
#define EndOfMatch(x,y)     MatchEnd(x,y)
#define IsSuccess(x,y)      (y ? (BitsMap(x) & (1 << (y))) : (BitsMap(x) & 1))

#define TokenType(x)    ((x)->Type)
#define TokenMode(x)    ((x)->Mode)
#define NextToken(x)    ((x)->Next)
#define BlockNo(x)      ((x)->Code.RefNo)
#define ClassList(x)    ((x)->Code.Clist)
#define LiteralChar(x)  ((x)->Code.Lit)
#define SelectList(x)   ((x)->Code.Selection)

#define ClassStart(x)   ((x)->Start)
#define ClassEnd(x)     ((x)->End)
#define NextClass(x)    ((x)->Next)

#define LIT         0
#define ANY         1
#define CCL         2
#define NCCL        3
#define BOL         4
#define EOL         5
#define BOW         6
#define EOW         7
#define BLOCK       8
#define BLREF       9
#define OR          10

#define CLOSURE1    0x01
#define CLOSURE2    0x02
#define CLOSURE3    0x04

#define RE_ANY      '.'
#define RE_CCL      '['
#define RE_NCCL     '^'
#define RE_CEND     ']'
#define RE_BOL      '^'
#define RE_EOL      '$'
#define RE_BOW      '<'
#define RE_EOW      '>'
#define RE_BOB      '('
#define RE_EOB      ')'
#define RE_CL1      '*'
#define RE_CL2      '+'
#define RE_CL3      '?'
#define RE_RNG      '-'
#define RE_ESC      '\\'
#define RE_OR       '|'

#define isnumber(x) (((x)>='0') && ((x)<='9'))
#define isoctal(x)  (((x)>='0') && ((x)<='7'))
#define ishexa(x)   (isnumber(x) || (((x)>='a') && ((x)<='f')))
#define iskanji(x)  (((x>=0x81) && (x<=0x9f)) || ((x>=0xe0) && (x<=0xfc)))
#define iseol(x)    ((x == '\0') || (x == '\n'))

#define min(x,y)    ((x)>(y) ? (y) : (x))
#define max(x,y)    ((x)>(y) ? (x) : (y))
#define abs(x)      ((x)<0 ? (-(x)) : (x))

#define htoi(x)     (isnumber(x) ? ((x)-'0') : ((x)-'a'+10))
#define otoi(x)     ((x)-'0')

void	refree();
RePat   *recomp();
Bool    re_search_forward();
void    re_init_func();
