/*****************************/
/*    SSdjDocTemplate.cpp    */
/*****************************/
#include "stdafx.h"
#include "WinSDJ.h"
#include "SSdjDocTemplate.h"
#include "sdjdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSSdjDocTemplate construction/destruction

CSSdjDocTemplate::CSSdjDocTemplate(UINT nIDResource,
	CRuntimeClass* pDocClass, CRuntimeClass* pFrameClass,
	CRuntimeClass* pViewClass)
		: CSingleDocTemplate(nIDResource, pDocClass, pFrameClass, pViewClass)
{
}

// _~[RXgN^BꂪȂƃRpCĂȂBB
CSSdjDocTemplate::CSSdjDocTemplate()
		: CSingleDocTemplate(0, NULL, NULL, NULL)
{
}

CSSdjDocTemplate::~CSSdjDocTemplate()
{
}

// CSingleDocTemplate(pParent̓t[EBhE̐eBbyRa)
CSDJDoc* CSSdjDocTemplate::OpenDocumentFile(LPCTSTR lpszPathName,
	BOOL bMakeVisible,CWnd *pParent)
	// if lpszPathName == NULL => create new file of this type
{
	CDocument* pDocument = NULL;
	CFrameWnd* pFrame = NULL;
	BOOL bCreated = FALSE;      // => doc and frame created
	BOOL bWasModified = FALSE;

	if (m_pOnlyDoc != NULL)
	{
		// already have a document - reinit it
		pDocument = m_pOnlyDoc;
//  hLg̏C`FbN͂ȂB
//  R-> SaveModified()̒AfxMessageBox\ɃvOI
//         ɕʂSaveModified() ASSERTƂȂB
//		if (!pDocument->SaveModified())
//			return NULL;        // leave the original one

//		pFrame = (CFrameWnd*)AfxGetMainWnd();
		// SDIet[擾Bq̊֐łMDĨCt[ɂȂB
		pFrame = GetFrameWnd();

		ASSERT(pFrame != NULL);
		ASSERT_KINDOF(CFrameWnd, pFrame);
		ASSERT_VALID(pFrame);
	}
	else
	{
		// create a new document
		pDocument = CreateNewDocument();
		ASSERT(pFrame == NULL);     // will be created below
		bCreated = TRUE;
	}

	if (pDocument == NULL)
	{
		AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
		return NULL;
	}
	ASSERT(pDocument == m_pOnlyDoc);

	if (pFrame == NULL)
	{
		ASSERT(bCreated);

		// create frame - set as main document frame
		BOOL bAutoDelete = pDocument->m_bAutoDelete;
		pDocument->m_bAutoDelete = FALSE;
					// don't destroy if something goes wrong
		pFrame = CreateNewFrame(pDocument, NULL);
		pDocument->m_bAutoDelete = bAutoDelete;
		if (pFrame == NULL)
		{
			AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
			delete pDocument;       // explicit delete on error
			return NULL;
		}
	}

	if (lpszPathName == NULL)
	{
		// create a new document
		SetDefaultTitle(pDocument);

		// avoid creating temporary compound file when starting up invisible
		if (!bMakeVisible)
			pDocument->m_bEmbedded = TRUE;

		if (!pDocument->OnNewDocument())
		{
			// user has been alerted to what failed in OnNewDocument
			TRACE0("CDocument::OnNewDocument returned FALSE.\n");
			if (bCreated)
				pFrame->DestroyWindow();    // will destroy document
			return NULL;
		}
	}
	else
	{
		CWaitCursor wait;

		// open an existing document
		bWasModified = pDocument->IsModified();
		pDocument->SetModifiedFlag(FALSE);  // not dirty for open

		if (!pDocument->OnOpenDocument(lpszPathName))
		{
			// user has been alerted to what failed in OnOpenDocument
			TRACE0("CDocument::OnOpenDocument returned FALSE.\n");
			if (bCreated)
			{
				pFrame->DestroyWindow();    // will destroy document
			}
			else if (!pDocument->IsModified())
			{
				// original document is untouched
				pDocument->SetModifiedFlag(bWasModified);
			}
			else
			{
				// we corrupted the original document
				SetDefaultTitle(pDocument);

				if (!pDocument->OnNewDocument())
				{
					TRACE0("Error: OnNewDocument failed after trying to open a document - trying to continue.\n");
					// assume we can continue
				}
			}
			return NULL;        // open failed
		}
#ifdef _MAC
		// if the document is dirty, we must have opened a stationery pad - don't
		// change the pathname because we want to treat the document as untitled
		if (!pDocument->IsModified())
#endif
			pDocument->SetPathName(lpszPathName);
	}

	// ̃t[EBhE̐eEBhEZbgB
	if (pParent)
		pFrame->SetParent(pParent);

	CWinThread* pThread = AfxGetThread();
	if (bCreated && pThread->m_pMainWnd == NULL)
	{
		// set as main frame (InitialUpdateFrame will show the window)
		pThread->m_pMainWnd = pFrame;
	}
	InitialUpdateFrame(pFrame, pDocument, bMakeVisible);

	return (CSDJDoc *)pDocument;
}

IMPLEMENT_DYNCREATE(CSSdjDocTemplate, CSingleDocTemplate)

BEGIN_MESSAGE_MAP(CSSdjDocTemplate, CSingleDocTemplate)
	//{{AFX_MSG_MAP(CSSdjDocTemplate)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSSdjDocTemplate bZ[W nh

CFrameWnd * CSSdjDocTemplate::GetFrameWnd()
{
	POSITION pos=m_pOnlyDoc->GetFirstViewPosition();
	CView *pView=m_pOnlyDoc->GetNextView(pos); // UADocView߂
	CFrameWnd *pFrame = pView->GetParentFrame(); // View炻̐eCFrameWnd߂
    return pFrame;
}
